package com.d4;

/**these packages are for OpenIntents
 *  simulator
*/ 


import org.openintents.hardware.Sensors; 

public class AccelerometerReader {

     
     boolean accelerometerAvailable = false;
     boolean isEnabled = false;
     
     /**Checks if Accelerometer is available on */
		
     public AccelerometerReader(boolean doEnable)
               throws UnsupportedOperationException {
    	 android.util.Log.i("FOUR","in constructor");
          /** Check once here in the constructor if an
           * Accelerometer is available on this device. 
          */
          for (String aSensor : Sensors.getSupportedSensors())
               if (aSensor.equals(Sensors.SENSOR_ACCELEROMETER))
                    accelerometerAvailable = true;

          if (!accelerometerAvailable)
               throw new UnsupportedOperationException(
                         "Accelerometer is not available.");

          if (doEnable) {
        	  android.util.Log.i("FIVE","enable sensor");
              setEnableAccelerometer(true);
          }
          android.util.Log.i("EIGHT","end constructor");
     }

      
     public void setEnableAccelerometer(boolean doEnable)
               throws UnsupportedOperationException {
    	 android.util.Log.i("SIX","in setEnableAccelerometer");
          if (!accelerometerAvailable)
               throw new UnsupportedOperationException(
                         "Accelerometer is not available.");

          /** If should be enabled and not already is: */
         if (doEnable && !this.isEnabled) {
               Sensors.enableSensor(Sensors.SENSOR_ACCELEROMETER);
               this.isEnabled = true;
          } else /** If should be disabled and not already is: */
         if (!doEnable && this.isEnabled) {
               Sensors.disableSensor(Sensors.SENSOR_ACCELEROMETER);
               this.isEnabled = false;
          }
         android.util.Log.i("SEVEN","end setEnableAccelerometer");
     }

     
      // Read out the values currently provided by the Accelerometer.
      
     public float[] readAccelerometer() throws UnsupportedOperationException, IllegalStateException {
    	 android.util.Log.i("FIVE","in readAccelerometer");
    	 if (!accelerometerAvailable)
               throw new UnsupportedOperationException(
                         "Accelerometer is not available.");

          if (!this.isEnabled)
               throw new IllegalStateException(
                         "Accelerometer was set to disabled!");
          
          int sensorValues = Sensors
                    .getNumSensorValues(Sensors.SENSOR_ACCELEROMETER);
          float[] out = new float[sensorValues];

         
          Sensors.readSensor(Sensors.SENSOR_ACCELEROMETER, out);
          
          android.util.Log.i("FIVE","in readAccelerometer");
          return out;
          
     }
}
